/*
* MisterPOS
* @copyright 	Copyright (c) 2018, Marco Moser
* @author       Marco Moser <marco.moser@webtonic.it>
* @version 	19/12/18 reinit
*/


////////////////////////////////////////////////////////////////////////////////
// gui object: gestisce il dato (add,inc,dec)

function Ticket_Queue() //var glob_ticket_queue
{
    this.tk_data=new TicketData();
    this.tk_sum_totale=0;
    this.last_idx=0;

    this.add_art = function(qt,ak,mdg_label)
    {
    	if (!glob_artitem_map[ak])
    	{
    	    alert('Articolo '+ak+' non disponibile'); // qt<0
    	    return;
    	}

    	// esiste gia'? lo toglie
	for(var ii=0;ii<this.tk_data.items.length;ii++)
	{
	    if (this.tk_data.items[ii].ak==ak && !this.tk_data.items[ii].mdesc)
	    {
		qt+=this.tk_data.items[ii].qt;
		this.tk_data.items.splice(ii,1);
		break;
	    }
	}
	var ec=glob_artitem_map[ak]['ec'];
	var mdesc=null;
	if (mdg_label)
	{
	    mdesc=mdg_label;
	    if (!glob_artitem_map[ak]['daymenu_keys']) ec=0; // lascia il menu con prezzo, gli item prezzo 0
	}

	this.tk_data.items.push(new TicketItem(qt,ak,glob_artitem_map[ak].desc,mdesc,ec,glob_artitem_map[ak].discounter));
	this.last_idx=this.tk_data.items.length-1;
	this.refresh_html(this.last_idx);
    }

    this.apply_modifier = function(mk)
    {
	var last_item=this.tk_data.items[this.last_idx];
	if (!last_item) return;
	var mdesc=null;
	if (last_item.qt>1) // splitta
	{
	    last_item.qt-=1;
	    this.tk_data.items.push(new TicketItem(1,last_item.ak,last_item.adesc,mdesc,last_item.ec,last_item.discounter));
	    this.last_idx=this.tk_data.items.length-1;
	    last_item=this.tk_data.items[this.last_idx];
	}

	mdesc=last_item.mdesc;
	if (!mdesc) mdesc='';
	var ec_desc=glob_moditem_map[mk].ec;
	var p1=mdesc.indexOf(glob_moditem_map[mk].desc);
	if (p1!=-1 && p1!=0)
	{
	    // inverte il modificatore +maionese -maionese
	    if (mdesc.charAt(p1-1)=='+')
	    {
	    	mdesc=mdesc.substr(0, p1-1) + '-' + mdesc.substr(p1);
		ec_desc=-ec_desc;
	    }
	    else
	    {
	    	mdesc=mdesc.substr(0, p1-1) + '+' + mdesc.substr(p1);
	    }
	}
	else mdesc+=' +'+glob_moditem_map[mk].desc;

	last_item.mdesc=mdesc;
	last_item.ec+=ec_desc;

	this.refresh_html(this.last_idx);
    }
    this.focus_item_qt = function(idx)
    {
    	this.last_idx=idx;
	this.refresh_html(idx);
    }
    this.inc_item_qt = function(idx)
    {
    	this.last_idx=idx;
	this.tk_data.items[idx].qt+=1;
	this.refresh_html(idx);
    }
    this.dec_item_qt = function(idx)
    {
    	this.last_idx=idx;
	if (this.tk_data.items[idx].qt>1) { this.tk_data.items[idx].qt-=1; this.refresh_html(idx); }
	else { this.tk_data.items.splice(idx,1); this.refresh_html(-1); }
    }
    // evidenzia hi_idx (maybe null)
    this.refresh_html = function(hi_idx)
    {
    	var ss='<div class="cart_summary">';
	var sum_euro=0;
	var sum_qt=0;
	var hasdiscounter=false;
	var sub_map={};
	var last_area=0;
	for(var ii=0;ii<this.tk_data.items.length;ii++)
	{
	    if (ii==hi_idx)
	    {
	    	last_area=glob_artitem_map[this.tk_data.items[ii].ak]['art_area'];
	    	ss+='<div class="cart_hi">';
	    	ss+=this.out_cart_item(this.tk_data.items[ii],ii);
	    	ss+='</div>';
	    }
	    else ss+=this.out_cart_item(this.tk_data.items[ii],ii);

	    if (this.tk_data.items[ii].discounter) hasdiscounter=true;
	    if (hasdiscounter) sum_euro=0;
	    else sum_euro+=this.tk_data.items[ii].qt*this.tk_data.items[ii].ec;

	    var my_area=glob_artitem_map[this.tk_data.items[ii].ak]['art_area'];
	    if (!sub_map[my_area]) sub_map[my_area]=0;
	    sub_map[my_area]+=this.tk_data.items[ii].qt;

	    sum_qt+=this.tk_data.items[ii].qt;
	}

	// totalone
	ss+='<div class="cart_tot">';
	ss+='TOTALE &euro; '+eur(sum_euro);
	ss+='</div>'; //cart_tot
	this.tk_sum_totale=sum_euro;

	if (sum_qt>0) $('#userdata_data').show();
	else $('#userdata_data').hide();
	ss+='</div>'; //cart_summary

	$("#cart_log").html(ss);
	$("#span_cart").html('Pz '+sum_qt+'').hide().fadeIn('slow');


	// varianti
	for(var mk in glob_moditem_map)
	{
	    if (glob_moditem_map[mk].art_area==last_area) gn("mod_item"+mk).style.display="";
	    else gn("mod_item"+mk).style.display="none";
	}
    }

    this.out_cart_item = function(ticket_item,idx)
    {
    	var ss='';
	ss+='<div class="cart_item">';

	ss+='<div class="cart_desc" onclick="glob_ticket_queue.focus_item_qt('+idx+')">';
	ss+='<span style="font-size: 150%;">';
	ss+=ticket_item.qt;
	ss+='</span>';
	ss+=' ';
	ss+=htmlspecialchars(ticket_item.adesc+" "+(ticket_item.mdesc||''));
	ss+=' x &euro; ';
	ss+=eur(ticket_item.ec);
	ss+='</div>'; //cart_desc

	ss+='<div class="cart_op">';
	ss+='<a class="cart_inc" href="javascript:void(glob_ticket_queue.inc_item_qt('+idx+'))">+</a>';
	ss+='&nbsp;';
	ss+='<a class="cart_dec" href="javascript:void(glob_ticket_queue.dec_item_qt('+idx+'))">-</a>';
	ss+='</div>'; //cart_op

	ss+='</div>'; //cart_item
    	return ss;
    }

}





////////////////////////////////////////////////////////////////////////////////
// event handlers

function onArea(area_key)
{
    try
    {
	// accende reparto
	for(var key in glob_areaitem_map)
	{
	    if (key==area_key) gn('menu_art'+key).style.display='';
	    else gn('menu_art'+key).style.display='none';
	}
	// spegne tavoli
	//gn('seatsbox').style.display='none';
	//gn('modop').style.display='none';

	//reset mdg daymenu
	if (mdg_last_ak)
	{
	    gn("mdgbox"+mdg_last_ak).style.display="none";
	    mdg_last_ak=null;
	    mdg_label=null;
	}
    }
    catch(exc)
    {
	alert('Exc='+exc);
    }
    window.location.href='#menu_name';
}
function onArticle(ak,area_key)
{
    // daymenu
    if (glob_artitem_map[ak]['daymenu_keys']) onComposite(ak,area_key); // ovvero ArticleBean.ART_TYPE_COMPOSITE
    glob_ticket_queue.add_art(1,ak,mdg_label);
}

var mdg_nr=1;
var mdg_label=null;
var mdg_last_ak=null;
function onComposite(ak,area_key)
{
    mdg_last_ak=ak;
    mdg_nr+=1;
    mdg_label=""+glob_artitem_map[ak]['desc']+" "+ArticleBean_MDG_PREFIX+mdg_nr; // menu unico mdg1
    gn("mdgbox"+ak).style.display="";
    gn('menu_art'+area_key).style.display='none';
}

function onModifier(mk)
{
    glob_ticket_queue.apply_modifier(mk);
}






////////////////////////////////////////////////////////////////////////////////
// form post


function btn_post_self_data(self_ticket_stus,self_ordine_minimo,self_dati_enable )
{
    console.log('btn_post_self_data self_dati_enable='+self_dati_enable );

    if (glob_ticket_queue.tk_sum_totale < self_ordine_minimo*100) // eurocent
    {
    	alert('Ordine minimo '+self_ordine_minimo+' Euro');
    	return false;
    }

    glob_ticket_queue.tk_data.opt["ticket_stus"]=self_ticket_stus;
    //skip if (self_dati_enable)
    if (1)
    {
    	var ee=[]; // errori
    	var ticket_self_map={};
    	$('.ticket_self_must').each(function() {
    		var inp_node=$(this);
    		var name=inp_node.attr('name');
    		var val=inp_node.val();
    		var lab=inp_node.data('inx_lab'); // data-inx_lab
    		if (val && val.match(/\w\w/) && val.length<200) //no tsj_seat=2 ma tsj_seat=12
    		{
    		    console.log('btn_post_self_data must name='+name);
    		    if (name=='tsj_seat'||name=='tsj_consegna') glob_ticket_queue.tk_data.opt[name]=val;
    		    else ticket_self_map[lab]=val;
    		}
    		else ee.push(lab);
    	});
    	$('.ticket_self_may').each(function() {
    		var inp_node=$(this);
    		var name=inp_node.attr('name');
    		var val=inp_node.val();
    		var lab=inp_node.data('inx_lab'); // data-inx_lab
    		if (val && val.match(/\w\w/) && val.length<200)
    		{
    		    console.log('btn_post_self_data may name='+name);
    		    if (name=='tsj_seat'||name=='tsj_consegna') glob_ticket_queue.tk_data.opt[name]=val;
    		    else ticket_self_map[lab]=val;
    		}
    	});
    	if (ee.length>0)
    	{
    	    alert('Dati incompleti, verifica: '+ee.join(', '));
    	    return false;
    	}
    	glob_ticket_queue.tk_data.opt['ticket_self_json']=JSON.stringify(ticket_self_map); //{"Nome sul campanello":"asfd","Via":"dsaf","Localita":"Trento"}
    }


    // jquery.ajax: evita di perdere l'ordine se il wifi e' fuori portata, la stampante non funziona, i piatti sono finiti
    $.ajax({
	type: 'POST',
	url: 'self_ajax.jssp',
	data: { ticketpost: JSON.stringify(glob_ticket_queue.tk_data) },
	success: function(data)
	{
	    if (data['errmsg']) alert(data['errmsg']);
	    else window.location.href='self_done.jssp?jsonmsg='+encodeURIComponent(JSON.stringify(data));
	},
	dataType: 'json'
    }).fail(function() { alert('Errore di comunicazione con il server, riprova') });
}



